#ifndef __INTERSECTION_H__
#define __INTERSECTION_H__

#include <stdlib.h>
#include <float.h>

#include "cvutils.h"

namespace ltflo {

typedef struct{double x; double y;} point;
typedef struct{long x; long y;} ipoint;
typedef struct{long mn; long mx;} rng;
typedef struct{ipoint ip; rng rx; rng ry; short in;} vertex;
typedef struct{point min; point max;} box;

#define bigReal DBL_MAX


/*Intersection of two polygons, from http://www.cap-lore.com/MathPhys/IP/*/
double intersectionArea(int na, point a[], int nb, point b[]);
double intersectionArea(const BBox& ba, const BBox& bb);

void range(box *B, point * x, int c);
void fit(point * x, int cx, vertex * ix, int fudge, double sclx, double scly, double mid, box B);
long area(ipoint a, ipoint p, ipoint q);
int ovl(rng p, rng q);
void cntrib(long *s, ipoint f, ipoint t, long w);
void int_cross(long *s, vertex * a, vertex * b, vertex * c, vertex * d, double a1, double a2, double a3, double a4);
void inness(long *s, vertex * P, int cP, vertex * Q, int cQ);
void bd(double * X, double y);
void bu(double * X, double y);


} // namespace ltflo



#endif // __INTERSECTION_H__


